#ifndef __XBEEPACKETS_FILE_OUTPUT_REALTIME_H__
#define __XBEEPACKETS_FILE_OUTPUT_REALTIME_H__

#include <fstream>
#include <sstream>
#include <string>
#include "XBeePackets.h"
#include <time.h>

using namespace std;

ofstream outputTxtArray[30];
ofstream outputMainLog;
ofstream outputRunFile;

double initTime;
double currentTime;
char packetFlags[NUMBER_OF_AGENTS]={0};



time_t rawtime;
struct tm dateAndTime;
errno_t err;

//
//
//printf ( "The current date/time is: %s",  );


void timerStart(void){
	initTime = clock();
}

int printToFile(XBeeInPacket& inPacket){
	if (!outputRunFile.is_open()){
		outputRunFile.open("run_me.m");
		outputRunFile<<"hold on; grid on; run main_log;"<<endl
					<<"for i = 1:length(agent_list)"<<endl
					<<"    if (agent_list(i) ~= 0)"<<endl
					<<"        figure(1);"<<endl
					<<"        plot(agents(i).time,agents(i).data(1,:),'b');"<<endl
					<<"        plot(agents(i).time,agents(i).data(3,:),'r');"<<endl
					<<"    end"<<endl
					<<"end"<<endl;

	}
	if (!outputMainLog.is_open()){
		//print timestamp and date in file
		outputMainLog.open("main_log.m");
		char buffer1[100];
		time ( &rawtime );
		err = localtime_s(&dateAndTime, &rawtime );
		if (err){
			outputMainLog<<"% error in localtime_s"<<endl;
		}
		else{
			err = asctime_s(buffer1,100, &dateAndTime);
		}
		if (err){
			outputMainLog<<"% error in asctime_s "<<endl;
		}
		else{
			outputMainLog<<"% "<<buffer1<<endl;
		}

	}
	char packetStructName[50];
	sprintf_s(packetStructName,50,"agent%iData",inPacket.source);
	
	if (packetFlags[inPacket.source] == 0){ //first time receving from this agent
		packetFlags[inPacket.source]=1;
		outputMainLog<<packetStructName<<".data=[";
		for (int i=0; i<DATA_ARRAY_LENGTH; i++){
			outputMainLog<<inPacket.data[i].dataFloat<<" ";
		}
		outputMainLog<<"]';"<<endl;
		outputMainLog<<packetStructName<<".time="<<(clock()-initTime)/CLOCKS_PER_SEC<<";"<<endl;
	}
	else {
		outputMainLog<<packetStructName<<".data(:,end+1)=[";
		for (int i=0; i<DATA_ARRAY_LENGTH; i++){
			outputMainLog<<inPacket.data[i].dataFloat<<" ";
		}
		outputMainLog<<"]';"<<endl;
		outputMainLog<<packetStructName<<".time(end+1)="<<(clock()-initTime)/CLOCKS_PER_SEC<<";"<<endl;
	}
	return 1;
}

void closeOutput(void){
	if (outputRunFile.is_open()){
		outputRunFile.close();
	}
	if (outputMainLog.is_open()){
		bool first_flag = 0;

			for (int i = 0; i<NUMBER_OF_AGENTS; i++){
				if (packetFlags[i] == 1){	//if we've received data from this agent
					char packetStructName[50];	//output data for this agent
					sprintf_s(packetStructName,50,"agent%iData",i);
					if (first_flag == 0){ //this is the first agent, initialize the structures
						first_flag = 1;
						outputMainLog<<endl;
						outputMainLog<<"agents = "<<packetStructName<<";"<<endl;
						outputMainLog<<"agent_list = "<<i<<";"<<endl;
					}
					else {
						outputMainLog<<"agents(end+1) = "<<packetStructName<<";"<<endl;
						outputMainLog<<"agent_list(end+1) = "<<i<<";"<<endl;
					}
				}
			}
		outputMainLog.close();
	}
}

#endif